//+------------------------------------------------------------------+
//|                                              SuperTrend.mq4 v1.2 |
//|                   Copyright  2008, Jason Robinson (jnrtrading). |
//|                                   http://www.spreadtrade2win.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jason Robinson."
#property link      "http://www.spreadtrade2win.com"

#property indicator_chart_window
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_buffers 2

extern int Nbr_Periods = 10;
extern double Multiplier = 3.0;
extern bool ShowText = true;
extern int Corner = 1;
extern int Trades = 10;

double TrendUp[], TrendDown[];
int changeOfTrend;
double trend[];
double up[],dn[];

int init() {
   IndicatorBuffers(5);
   SetIndexBuffer(0, TrendUp);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(0, "Trend Up");
   SetIndexBuffer(1, TrendDown);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(1, "Trend Down");
   SetIndexBuffer(2, up);
   SetIndexBuffer(3, dn);
   SetIndexBuffer(4, trend);
   return(0);
}
void DeleteObjects() {
   for (int i=ObjectsTotal()-1;i>=0;i--)
      if (StringFind(ObjectName(i),"Super")>-1) ObjectDelete(ObjectName(i));
   return;
}
void deinit() {
   DeleteObjects();
   return;
}

int start() {
   int limit, i, flag, flagh;
   double medianPrice, atr;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit=Bars-counted_bars;
   for (i = limit; i >= 0; i--) {
      TrendUp[i] = EMPTY_VALUE;
      TrendDown[i] = EMPTY_VALUE;
      atr = iATR(NULL, 0, Nbr_Periods, i);
      medianPrice = (High[i]+Low[i])/2;
      up[i]=medianPrice+(Multiplier*atr);
      dn[i]=medianPrice-(Multiplier*atr);
      trend[i]=1;
      
      if (Close[i]>up[i+1]) {
         trend[i]=1;
         if (trend[i+1] == -1) changeOfTrend = 1;
      }
      else if (Close[i]<dn[i+1]) {
         trend[i]=-1;
         if (trend[i+1] == 1) changeOfTrend = 1;
      }
      else if (trend[i+1]==1) {
         trend[i]=1;
         changeOfTrend = 0;       
      }
      else if (trend[i+1]==-1) {
         trend[i]=-1;
         changeOfTrend = 0;
      }

      if (trend[i]<0 && trend[i+1]>0) {
         flag=1;
      }
      else {
         flag=0;
      }
      
      if (trend[i]>0 && trend[i+1]<0) {
         flagh=1;
      }
      else {
         flagh=0;
      }
      
      if (trend[i]>0 && dn[i]<dn[i+1])
         dn[i]=dn[i+1];
      
      if (trend[i]<0 && up[i]>up[i+1])
         up[i]=up[i+1];
      
      if (flag==1)
         up[i]=medianPrice+(Multiplier*atr);
         
      if (flagh==1)
         dn[i]=medianPrice-(Multiplier*atr);
         
      if (trend[i]==1) {
         TrendUp[i]=dn[i];
         if (changeOfTrend == 1) {
            TrendUp[i+1] = TrendDown[i+1];
            changeOfTrend = 0;
         }
      }
      else if (trend[i]==-1) {
         TrendDown[i]=up[i];
         if (changeOfTrend == 1) {
            TrendDown[i+1] = TrendUp[i+1];
            changeOfTrend = 0;
         }
      }
   }
   WindowRedraw();
   if (ShowText) {
      i=0;
      int Ct=1,pb;
      double ClosePrice = Close[i];
      double pr;
      int lastbar=i;
      double OpenPrice = 0;
      while (i<MathMax(limit,500)) {
         if (trend[i]>0 && trend[i+1]<0) {
            OpenPrice=Open[i];
            pb=iHighest(NULL,0,MODE_HIGH,i-lastbar,lastbar);
            pr=High[pb]+20*MathSqrt(Period())*Point;
            lastbar=i;
            if (ClosePrice-OpenPrice>0) {
               if (Ct<=Trades) DrawText(Ct,Green,"T");
               DrawPB(Ct,Green,"T",pb,pr);
               }
            else {
               if (Ct<=Trades) DrawText(Ct,Green,"F");
               DrawPB(Ct,Green,"F",pb,pr);
               }
            ClosePrice=OpenPrice;
            Ct++;
            }
         else if (trend[i]<0 && trend[i+1]>0) {
            OpenPrice=Open[i];
            pb=iLowest(NULL,0,MODE_LOW,i-lastbar,lastbar);
            pr=Low[pb]-MathSqrt(Period())*Point;
            lastbar=i;
            if (OpenPrice-ClosePrice>0) {
               if (Ct<=Trades) DrawText(Ct,Red,"T");
               DrawPB(Ct,Red,"T",pb,pr);
               }
            else {
               if (Ct<=Trades) DrawText(Ct,Red,"F");
               DrawPB(Ct,Red,"F",pb,pr);
               }
            ClosePrice=OpenPrice;
            Ct++;
            }
         i++;    
         }
      }
   return(0);
}
void DrawText (int num, color OPclr, string OPstr) {
   string name = "Super";
   ObjectCreate(name+num+"n", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(name+num+"n", IntegerToString(num), 15, "Arial Bold", Gray);
   ObjectSet(name+num+"n", OBJPROP_CORNER, Corner);
   ObjectSet(name+num+"n", OBJPROP_XDISTANCE, 20+25*(num-1));
   ObjectSet(name+num+"n", OBJPROP_YDISTANCE, 20);
   ObjectCreate(name+num, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(name+num, OPstr, 15, "Arial Bold", OPclr);
   ObjectSet(name+num, OBJPROP_CORNER, Corner);
   ObjectSet(name+num, OBJPROP_XDISTANCE, 20+25*(num-1));
   ObjectSet(name+num, OBJPROP_YDISTANCE, 40);
   return;
}
void DrawPB (int num, color OPclr, string OPstr, int pos, double price) {
   string name = "Super";
   ObjectCreate(name+num+"s", OBJ_TEXT, 0, 0, 0);
   ObjectSetText(name+num+"s", OPstr, 20, "Arial Bold", OPclr);
   ObjectSet(name+num+"s", OBJPROP_PRICE1, price);
   ObjectSet(name+num+"s", OBJPROP_TIME1, Time[pos]);
   return;
}
